package com.imageresizer;



import android.os.Environment;
import android.util.Log;

import java.io.File;
import java.io.IOException;
import java.util.UUID;

public class FileUtility {

    private static final String TAG = FileUtility.class.getSimpleName();

    public String getUniqueName() {
        return "out_" + UUID.randomUUID().toString();
    }


    public File createOutputFile(String format) {
        String newFileName = getUniqueName() + "." + format.toLowerCase();

        File sd = Environment.getExternalStorageDirectory();
        File down = new File(sd, Environment.DIRECTORY_DOWNLOADS + "/output");
        File file = new File(down, newFileName);

        // Check if the file exists
        if (!file.exists()) {
            try {
                // Create the file and its parent directories if they don't exist
                if (file.getParentFile() != null && !file.getParentFile().exists()) {
                    file.getParentFile().mkdirs();
                }

                // Create the actual file
                file.createNewFile();

                Log.d(TAG, "File created: " + file.getAbsolutePath());
            } catch (IOException e) {
                e.printStackTrace();
                Log.d(TAG, "Error creating the file: " + e.getMessage());
            }
        } else {
            Log.d(TAG, "File already exists: " + file.getAbsolutePath());
        }
        return file;
    }
}
