package com.imageresizer;

import java.util.HashMap;
import java.util.Map;

public enum ImageFormatType {
    JPEG("jpeg"),
    PNG("png"),
    WEBP("webp"),
    AWEBP("awebp"),
    GIF("gif");

    private final String format;

    ImageFormatType(String format) {
        this.format = format.toLowerCase();
    }
    public String getType() {
        return format;
    }

    public static ImageFormatType fromString(String format) {
        for (ImageFormatType imageFormat : values()) {
            if (imageFormat.format.equalsIgnoreCase(format)) {
                return imageFormat;
            }
        }
        return JPEG;
    }

    public static Map<String, String> asMap() {
        Map<String, String> map = new HashMap<>();
        for (ImageFormatType imageFormat : values()) {
            map.put(imageFormat.getType().toUpperCase(), imageFormat.getType().toLowerCase());
        }
        return map;
    }

}
